<?php

use App\Classes\ValueObjects\Constants\ApprovalStatus;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateBillGroupsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('bill_groups', function (Blueprint $table) {
            $table->id();
            $table->string('reference')->unique();
            $table->foreignId('issuer')->unsigned();
            $table->foreignId('receiver')->unsigned();
            $table->decimal('amount', 14, 5)->default(0.00);
            $table->decimal('original_amount', 14, 5)->default(0.00);
            $table->foreignId('currency_id')->unsigned();
            $table->foreignId('original_currency_id')->unsigned();
            $table->decimal('currency_rate', 14, 5)->default(0.00);
            $table->decimal('tax', 14, 5)->default(0.00);
            $table->decimal('service_charge', 14, 5)->default(0.00);
            $table->integer('status')->default(ApprovalStatus::PENDING_VERIFICATION);
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('bill_groups');
    }
}
